/* GCC */

#define maxN 100 //    n
#define mod 101 // ,      

#include <stdio.h>

int n, a[maxN][maxN]; //  
int cnt[maxN][maxN][maxN]; // cnt[d][cl][cr]      (cl, cr)
    //      d (        )

// getValue  (    )     cnt[d][cl][cr]
int getValue(int d, int cl, int cr)
{
    if (cl < 0 || cl > d || cr < 0 || cr > d) //     ,  0
        return 0;
    int v = cnt[d][cl][cr];
    if (v == -1) //      ,   
    {
        if (a[cl][d - cl] == a[n - 1 - d + cr][n - 1 - cr]) //     
        {
            if (d == 0) //    ,    
                v = 1;
            else //      (   101)
                v = (getValue(d - 1, cl, cr)
                    + getValue(d - 1, cl - 1, cr)
                    + getValue(d - 1, cl, cr - 1)
                    + getValue(d - 1, cl - 1, cr - 1)) % mod;
        }
        else //     ,       
            v = 0;
        cnt[d][cl][cr] = v;
    }
    return v;
}

int main()
{
    freopen("table.in", "r", stdin);
    freopen("table.out", "w", stdout);

    //  
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            scanf("%d", &a[i][j]);

    //   -1 (  )    
    for (int d = 0; d < n; d++)
        for (int i = 0; i <= d; i++)
            for (int j = 0; j <= d; j++)
                cnt[d][i][j] = -1;

    //        (   
    //  100     100,        )
    int ans = 0;
    for (int i = 0; i < n; i++)
        ans += getValue(n - 1, i, i);

    //     101
    printf("%d\n", ans % mod);
}
